/*
    $Id: StrangeFilter.java,v 1.1 2003/07/03 04:10:35 admin Exp $
    -----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package action.strange;
import action.*;
import action.strange.*;
import java.lang.reflect.*;
import java.util.*;
import java.util.regex.*;

public class StrangeFilter implements BottleAction {
    // 0̘AԂłANUM_CHECK_ITEMS͕Klݒ肳ĂKv܂B
    public static final int CHK_NONTERMINATE = 0;
    public static final int CHK_SCOPE = 1;
    public static final int CHK_SURFACE = 2;
    public static final int NUM_CHECK_ITEMS = 3;
    public static final String[] human_readable_check_type = {
	"\u00a5t",
	"scope",
	"surface",
	// "wait before scope",
    };
    public static final String[] for_memento_check_type = {
	"check-nonterminate-tag",
	"check-scope-tag",
	"check-surface-tag",
	// "check-wait-before-scope-tag",
    };
    public static Method[] checker_methods = null;
    
    WindowController wc;

    boolean[] standard;
    boolean drop_from_log;

    public StrangeFilter() {
	this.wc = new WindowController(this);
	this.standard = new boolean[NUM_CHECK_ITEMS];
	this.drop_from_log = false;

	// ̃ftHglݒ
	standard[CHK_NONTERMINATE] = true;
	standard[CHK_SCOPE] = true;
	standard[CHK_SURFACE] = true;
    }

    public StrangeFilter(Map memento) {
	this();
	standard[CHK_NONTERMINATE] =
	    ((Number)memento.get(for_memento_check_type[CHK_NONTERMINATE])).intValue() != 0;
	standard[CHK_SCOPE] =
	    ((Number)memento.get(for_memento_check_type[CHK_SCOPE])).intValue() != 0;
	standard[CHK_SURFACE] =
	    ((Number)memento.get(for_memento_check_type[CHK_SURFACE])).intValue() != 0;
	drop_from_log =
	    ((Number)memento.get("drop-also-from-log")).intValue() != 0;
    }

    public boolean getCheck(int type) {
	return standard[type];
    }

    protected void setCheck(int type, boolean flag) {
	standard[type] = flag;
    }

    public boolean getDropFromLog() {
	return drop_from_log;
    }

    protected void setDropFromLog(boolean bool) {
	drop_from_log = bool;
    }

    public void configure(Object target, Method ok, Method cancel) {
	wc.configure(target, ok, cancel);
    }

    public String getConfiguration() {
	StringBuffer conf = new StringBuffer();
	for (int i = 0; i < NUM_CHECK_ITEMS; i++) {
	    if (standard[i]) {
		if (conf.length() > 0) {
		    conf.append(", ");
		}
		conf.append(human_readable_check_type[i]);
	    }
	}
	conf.insert(0, '[');
	conf.append(']');

	if (drop_from_log) {
	    conf.append(" (drop log)");
	}

	return conf.toString();
    }

    public String getStatus() {
	return "ok";
    }

    public void destruct() {
    }

    public ActionReply doAction(ActionRequest req) {
	if (checker_methods == null) {
	    // \bhLbVĂȂB
	    Pattern pat_minus = Pattern.compile("-");
	    checker_methods = new Method[NUM_CHECK_ITEMS];
	    for (int i = 0; i < NUM_CHECK_ITEMS; i++) {
		// for_memento_check_typẽnCtA_[XRAɊւ̂
		// `FbNp̃\bhłB
		try {
		    checker_methods[i] = getClass().getMethod(
			pat_minus.matcher(for_memento_check_type[i]).replaceAll("_"),
			new Class[] {ActionRequest.class});
		}
		catch (Exception e) {
		    System.out.println("Internal error of StrangeFilter.");
		    e.printStackTrace();
		}
	    }
	}

	boolean drop_required = false;
	for (int i = 0; i < NUM_CHECK_ITEMS; i++) {
	    if (standard[i]) {
		try {
		    // `FbNp\bh́A`FbNɈ|ꍇtrueԂB
		    drop_required =
			((Boolean)checker_methods[i].invoke(
			    this, new Object[] {req})).booleanValue();
		    if (drop_required) {
			break; // ł`FbNɈ|ȂAȏ`FbN㔂ӖB
		    }
		}
		catch (Exception e) {
		}
	    }
	}

	ActionReply rep = new ActionReply();
	if (drop_required) {
	    rep.setDrop(drop_from_log);
	}
	return rep;
    }

    public Map getMemento() {
	// Ȍ̃tOyёSẴ`FbNtO
	Hashtable memento = new Hashtable();
	memento.put("drop-also-from-log", new Integer(drop_from_log ? 1 : 0));
	for (int i = 0; i < NUM_CHECK_ITEMS; i++) {
	    memento.put(
		for_memento_check_type[i], new Integer(standard[i] ? 1 : 0));
	}
	return memento;
    }

    public static String getName() {
	return "Strange Filter";
    }

    
    // `FbNp\bhBdoActionԐړIɌĂ΂B
    // ʉ߂Ȃ̂ł΁AtrueԂB
    
    public boolean check_nonterminate_tag(ActionRequest req) {
	return !req.getScript().startsWith("\u00a5t");
    }

    private static String regex_scope = "\u00a5[01hu]";
    protected static Pattern pat_scope = Pattern.compile(regex_scope);
    public boolean check_scope_tag(ActionRequest req) {
	return !pat_scope.matcher(req.getScript()).find();
    }

    // DȐK\łA͖łcB
    private static Pattern pat_surface = Pattern.compile("\u00a5s");
    public boolean check_surface_tag(ActionRequest req) {
	return !pat_surface.matcher(req.getScript()).find();
    }

/*    
    private static Pattern pat_synch_and_url = Pattern.compile(
	"\u00a5_s.+?\u00a5_s|\u00a5URL(?:\\[.+?\\])+");
    private static Pattern pat_wait_before_scope = Pattern.compile(
	regex_scope+".*?\u00a5_?w.*?"+regex_scope);
    private static Pattern pat_nowait_before_scope = Pattern.compile(
	regex_scope+".*?"+regex_scope);
	public boolean check_wait_before_scope_tag(ActionRequest req) {*/
	/*
	  ̂₤ȃWbNɏ]ӁB蔲łAƂȂΌɏCB
	  1. \_sŚ܂ꂽ͚́A\w9ƂĈӁB
	  2. \URL[][]...\w9ƂĈӁB
	  3. XR[vؑց`\w`XR[vؑւƂ΃`FbNʉ߁B
	  4. XR[vؑց`\_w`XR[vؑւƂĂ`FbNʉ߁B
	  5. XR[vؑց`XR[vؑւƂ΁A`FbNB
	  6. ŏIIɂ̓`FbNʉ߁B
	*/
	/*String script =
	    pat_synch_and_url.matcher(req.getScript()).replaceAll("\u0015w9");
	
	if (pat_wait_before_scope.matcher(script).find()) {
	    // ʉ
	    return false;
	}

	if (pat_nowait_before_scope.matcher(script).find()) {
	    // `FbN
	    return true;
	}

	return false;
    }
*/
}