/*
    $Id: WindowController.java,v 1.1 2003/07/03 04:10:35 admin Exp $
    -----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package action.strange;
import action.strange.*;
import java.lang.reflect.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class WindowController extends NSWindowController {
    StrangeFilter strange;
    Object config_callback_target;
    Method config_callback_ok;
    Method config_callback_cancel;

    public NSButton check_nonterminate; /* IBOutlet */
    public NSButton check_scope; /* IBOutlet */
    public NSButton check_surface; /* IBOutlet */
    public NSButton drop_log; /* IBOutlet */

    public WindowController(StrangeFilter strange) {
	super("ActionStrangeFilter");
	loadWindow();
	this.strange = strange;
    }

    public void configure(Object callback_target,
			  Method callback_ok,
			  Method callback_cancel) {
	config_callback_target = callback_target;
	config_callback_ok = callback_ok;
	config_callback_cancel = callback_cancel;

	check_nonterminate.setIntValue(
	    strange.getCheck(StrangeFilter.CHK_NONTERMINATE) ? 1 : 0);
	check_scope.setIntValue(
	    strange.getCheck(StrangeFilter.CHK_SCOPE) ? 1 : 0);
	check_surface.setIntValue(
	    strange.getCheck(StrangeFilter.CHK_SURFACE) ? 1 : 0);
	drop_log.setIntValue(strange.getDropFromLog() ? 1 : 0);

	showWindow(this);
    }

    public void cancel(Object sender) { /* IBAction */
	window().close();

	if (config_callback_target != null &&
	    config_callback_cancel != null) {
	    try {
		config_callback_cancel.invoke(
		    config_callback_target,new Object[] {strange});
	    } catch (Exception e) {}
	}
    }

    public void ok(Object sender) { /* IBAction */
	strange.setCheck(
	    StrangeFilter.CHK_NONTERMINATE, check_nonterminate.intValue() != 0);
	strange.setCheck(
	    StrangeFilter.CHK_SCOPE, check_scope.intValue() != 0);
	strange.setCheck(
	    StrangeFilter.CHK_SURFACE, check_surface.intValue() != 0);
	strange.setDropFromLog(drop_log.intValue() != 0);

	window().close();

	if (config_callback_target != null &&
	    config_callback_ok != null) {
	    try {
		config_callback_ok.invoke(
		    config_callback_target,new Object[] {strange});
	    } catch (Exception e) {}
	}
    }
}
