/*
    $Id: Bottle.java,v 1.1 2003/08/26 16:50:55 admin Exp $
    -----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log;
import log.*;
import java.util.*;

public class Bottle {
    String mid;
    // datetimemid֍݂΍̂ŁAKv̂ɃZbgȂB
    String date;
    String time;
    
    String channel;
    //String script;
    char[] script;
    String ifghost;
    String fbmsg;
    int vote;
    int agree;

    Map remarks; //  => Cӂ̒l

    public Bottle() {
	
    }

    public int size() {
	// ̈r߂郁̃TCYB铂̒lŗǂB
	int s = 0;
	if (mid != null) s += mid.length() * 2;
	if (date != null) s += date.length() * 2;
	if (time != null) s += time.length() * 2;
	if (channel != null) s += channel.length() * 2;
	if (script != null) s += script.length * 2;
	if (ifghost != null) s += ifghost.length() * 2;
	if (fbmsg != null) s += fbmsg.length() * 2;
	s += 4; // vote
	s += 4; // agree
	return s;
    }

    public String getMID() {
	return mid;
    }
    public void setMID(String mid) {
	this.mid = mid;
    }

    public String getChannel() {
	return channel;
    }
    public void setChannel(String channel) {
	this.channel = channel.intern();
    }

    public String getScript() {
	return new String(script);
    }
    public void setScript(String script) {
	// String^̂܂ܕۑƁAʂɂȂB
	this.script = script.toCharArray();
    }

    public String getIfGhost() {
	return ifghost;
    }
    public void setIfGhost(String ifghost) {
	this.ifghost = ifghost.intern();
    }

    public int getVote() {
	return vote;
    }
    public void setVote(int vote) {
	this.vote = vote;
    }
    public void setVote(String vote) {
	try {
	    this.vote = Integer.parseInt(vote);
	}
	catch (Exception e) {
	    this.vote = 0;
	}
    }

    public int getAgree() {
	return agree;
    }
    public void setAgree(int agree) {
	this.agree = agree;
    }
    public void setAgree(String agree) {
	try {
	    this.agree = Integer.parseInt(agree);
	}
	catch (Exception e) {
	    this.agree = 0;
	}
    }

    public String getDate() {
	if (mid == null) {
	    return date;
	}
	else {
	    if (date == null) {
		extractTimeFromMid();
	    }
	    return date;
	}
    }
    public void setDate(String date) {
	this.date = date.intern();
    }

    public String getTime() {
	if (mid == null) {
	    return time;
	}
	else {
	    if (time == null) {
		extractTimeFromMid();
	    }
	    return time;
	}
    }
    public void setTime(String time) {
	this.time = time;
    }

    public String getFBMsg() {
	return fbmsg;
    }
    public void setFBMsg(String fbmsg) {
	this.fbmsg = fbmsg;
    }

    public Object getRemark(String key) {
	if (remarks == null) {
	    return null;
	}
	else {
	    return remarks.get(key);
	}
    }
    public void setRemark(String key, Object value) {
	if (remarks == null) {
	    remarks = Collections.synchronizedMap(new TreeMap());
	}
	remarks.put(key.intern(), value);
    }

    protected void extractTimeFromMid() {
	Calendar cal = MidAnalyzer.analyzeTimeStampFromMid(mid);
	
	String date = pad(cal.get(Calendar.MONTH)+1,2)+
	    pad(cal.get(Calendar.DAY_OF_MONTH),2)+
	    pad(cal.get(Calendar.YEAR),4);
	this.date = date.intern();
	
	String time = pad(cal.get(Calendar.HOUR_OF_DAY),2)+
	    pad(cal.get(Calendar.MINUTE),2)+
	    pad(cal.get(Calendar.SECOND),2);
	this.time = time;
    }

    public static String pad(int n,int chars) {
	StringBuffer buf = new StringBuffer(chars);
	String str_n = Integer.toString(n);
	
	int n_pad = chars - str_n.length();
	for (int i = 0; i < n_pad; i++) {
	    buf.append('0');
	}
	buf.append(str_n);
	
	return buf.toString();
    }
}
