/*
	$Id: TextTemplate.java,v 1.1.1.1 2003/04/08 14:55:47 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2003 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log.logviewer;
import java.util.*;
import java.io.*;

public class TextTemplate
{
	String content;
	Hashtable replace_table;
	
	public TextTemplate(String content)
	{
		this.content = content.trim();
		replace_table = new Hashtable();
	}
	
	public TextTemplate copy()
	{
		return new TextTemplate(content);
	}
	
	public String evaluate() {
		StringBuffer buf = new StringBuffer(content);
		
		for (Enumeration e = replace_table.keys();e.hasMoreElements();) {
			String key = (String)e.nextElement();
			String to_find = "<!-- "+key+" -->";
			String value = (String)replace_table.get(key);
			
			
			int key_pos;
			while ((key_pos = buf.toString().indexOf(to_find)) != -1) {
				buf.replace(key_pos,key_pos+to_find.length(),value);
			}
		}
		
		return buf.toString();
	}
	
	public TextTemplate set(String key,String value)
	{
		if (key != null && value != null) {
			replace_table.put(key,value);
		}
		return this;
	}
	
	public TextTemplate cancel(String key)
	{
		if (key != null) {
			replace_table.remove(key);
		}
		return this;
	}
}